.nolist
include	\masm32\include\masm32rt.inc

CrLf	EQU	13,10
cs2b  PROTO C :DWORD,:DWORD,:VARARG	; modified szMultiCat

.data?
pBuf		dd ?
StrBuffer	db 256 dup (?)

.code

MulByte MACRO ToEax:REQ, mul:REQ	;works fine if the result is between 0 and 255
  mov eax, ToEax
  shl eax,8		; mov into AH
  db 0D5h,mul	; multiply AL
  EXITM <eax>
ENDM

GetCell MACRO Row:REQ, Col:REQ
  mov edx,offset RowLen
  mov ecx,MulByte([edx],Row)	; get pos of row
  add ecx,Col		; add pos of column
  add ecx,ecx		; multiply with four
  add ecx,ecx		; since table is dd
  mov edx,offset MyFlatBuffer
  EXITM <[edx+ecx]>
ENDM

MyFlatBuffer:
	dd 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28
	dd 29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53

RowLen	dd 7

start:
  invoke SetConsoleTitle,chr$("Testing the AAM and AAD opcodes:")
  mov	pBuf,offset StrBuffer
  print chr$("This little program uses an undocumented variant",CrLf)
  print chr$("of the AAM opcode for simple multiplication.",CrLf)
  print chr$(CrLf,"Advantages:",CrLf)
  print chr$(9,"code is 2 bytes shorter than MUL",CrLf)
  print chr$(9,"edx is not needed for multiplication",CrLf)
  print chr$("Disadvantages:",CrLf)
  print chr$(9,"works only if the result is BYTE, i.e. lower than 256",CrLf)

  print chr$(CrLf,"Each row of our table has ")
  mov eax,offset RowLen
  print str$([eax])
  print chr$(" elements (* for some examples below):",CrLf)

  print chr$(CrLf,"Row 0:",9,"0*,1,2,3,4,5,6")
  print chr$(CrLf,"Row 1:",9,"7,8*,9,10,11,12,13")
  print chr$(CrLf,"Row 2:",9,"14,15,16,17*,18,19,20")
  print chr$(CrLf,"Row 3:",9,"21,22,23*,24,25,26,27")
  print chr$(CrLf,"Row 4:",9,"28,29,30**,31,32,33,34")
  print chr$(CrLf) ; OK, the fun starts here

  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 0:0 = "), str$(GetCell(0,0)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 1:1 = "), str$(GetCell(1,1)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 2:3 = "), str$(GetCell(2,3)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 3:2 = "), str$(GetCell(3,2)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 1:6 = "), str$(GetCell(1,6)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 2:6 = "), str$(GetCell(2,6)))
  print rv(cs2b,2,pBuf, chr$(CrLf,"Cell 3:6 = "), str$(GetCell(3,6)))

  print chr$(CrLf,CrLf,"Usage:",CrLf)
  print chr$("print rv(cs2b,2,pBuf,chr$(CrLf,",34,"Cell 2:3=",34,"),str$(GetCell(2,3)))",CrLf,CrLf)

  ; mov eax,rv(cs2b,2,pBuf, chr$("Test the power of macros:",CrLf,"Cell 4:0 = "), str$(GetCell(4,0)))
  ; invoke MessageBox,NULL,eax,chr$("Doesn't look like Assembler, right?"),MB_OK
  ; just for fun ;-)
  invoke MessageBox,NULL,rv(cs2b,2,pBuf, chr$("Test the power of macros:",CrLf,"Cell 4:2 = "), str$(GetCell(4,2))),chr$("Doesn't look like Assembler, right?"),MB_OK

  invoke ExitProcess,0

;	-------------------------------------------------
;	The module below is based on szMultiCat
;	by Alexander Yackubtchik
;	Modified by jj2007:
;	In contrast to szMultiCat, cs2b ("concat string to buffer")
;	will always write the first string to the start of the buffer.
;	--------------------------------------------------

cs2b proc C pcount:DWORD,lpBuffer:DWORD,args:VARARG

    push esi
    push edi

    mov edi,lpBuffer
    xor ecx,ecx
    lea edx,args

COMMENT # jj2007 11.12.2007
The following lines have been commented
out to simulate a fresh start
	dec edi
	@@:
	inc edi
	mov al,[edi]
	or al,al
	jne @B	
#
    newstr:
    dec edi
    mov esi,[edx][ecx*4]
  @@:
    inc edi
    mov al,[esi]
    mov [edi],al
    inc esi
    or al,al
    jne @B
    inc ecx
    cmp ecx,pcount
    jne newstr

    mov eax, lpBuffer

    pop edi
    pop esi

    ret

cs2b endp
end start
; OPT_SUSY CONSOLE	; AsmBuild option: assemble as console app
